classification
Title: test_long_lines() fails randomly on AMD64 Windows7 SP1 3.x
Type: Stage: resolved
Components: Tests Versions: Python 3.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: barry, haypo, jkloth, r.david.murray
Priority: normal Keywords:

Created on 2017-05-15 16:17 by haypo, last changed 2017-07-03 13:25 by haypo. This issue is now closed.

Messages (9)
msg293721 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-05-15 16:17
http://buildbot.python.org/all/builders/AMD64%20Windows7%20SP1%203.x/builds/436/steps/test/logs/stdio

======================================================================
FAIL: test_long_lines (test.test_email.test_email.TestFeedParsers)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "C:\buildbot.python.org\3.x.kloth-win64\build\lib\test\test_email\test_email.py", line 3526, in test_long_lines
    self.assertEqual(m.get_payload(), 'x'*M*N)
AssertionError: 'xxxx[17103482 chars]xxxxxzxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx[2896464 chars]xxxx' != 'xxxx[17103482 chars]xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx[2896464 chars]xxxx'


Notice the "z" in "...xxxxxz...".
msg293805 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-05-16 21:59
New fail, same buildbot:

======================================================================
FAIL: test_long_lines (test.test_email.test_email.TestFeedParsers)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "C:\buildbot.python.org\3.x.kloth-win64\build\lib\test\test_email\test_email.py", line 3534, in test_long_lines
    self.assertEqual(m.items(), [('a', ''), ('b', 'x'*M*N)])
AssertionError: Lists differ: [('a'[1845894 chars]xxxxxzxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx[18154072 chars]xx')] != [('a'[1845894 chars]xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx[18154072 chars]xx')]

First differing element 1:
('b',[1845882 chars]xxxxxzxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx[18154071 chars]xxx')
('b',[1845882 chars]xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx[18154071 chars]xxx')

  [('a', ''),
   ('b',


Don't click on http://buildbot.python.org/all/builders/AMD64%20Windows7%20SP1%203.x/builds/439/steps/test/logs/stdio : the log contains lines of 2 MB which make my Firefox super slow :-)
msg293810 - (view) Author: Jeremy Kloth (jkloth) * Date: 2017-05-16 22:21
Watch this space, but I'm pretty sure that it is (was) bad memory.  It passes memtest86+ but I had issues with these kits in other machines.  I swapped out the stick I believe that had the stuck bit.  

Unfortunately, it is a wait and see solution, as they do pass memtest86+, just not the Python test suite ;)
msg293811 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-05-16 22:26
> Watch this space, but I'm pretty sure that it is (was) bad memory.

It's really strange that only one very specific Python test fails if it's a bad memory issue?
msg293815 - (view) Author: Jeremy Kloth (jkloth) * Date: 2017-05-16 22:33
My thinking is that in normal running, the in-use memory is below the bad bit.  It is due to that test using such a large chunk of memory that it pushes the data into the bad area.  I would wager that if largemem tests were run, the would error as well.
msg293817 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-05-16 22:44
If you are sure that your memory has issues, don't test it, just change it. I had memory issues once but memtest86 was quick to prove memory errors in my case. I changed the memory for free since it was still under the warranty.
msg293821 - (view) Author: Jeremy Kloth (jkloth) * Date: 2017-05-16 23:21
That's the real problem, I'm not *sure* it's the memory, but it does have the symptoms.  And that is why my buildbot was down earlier, I was attempting to determine the bad stick and replace it.  I'm just hoping I changed the right one.  That is why I brought up the testing (they both pass memtest).

So far so good, no test_email issues after the change, but only 2 runs in.
msg293823 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-05-17 00:00
See also bpo-20118: test_linetoolong() of test_imaplib is skipped "temporarily" on Python 2.7 since 2014 :-)
msg297580 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-07-03 13:25
Jeremy Kloth changed a memory stick on his physical server. I didn't see this bug recently, so I consider that the bug is fixed.

Thank you Jeremy!
History
Date User Action Args
2017-07-03 13:25:22hayposetstatus: open -> closed
resolution: fixed
messages: + msg297580

stage: resolved
2017-05-17 00:00:46hayposetmessages: + msg293823
2017-05-16 23:21:51jklothsetmessages: + msg293821
2017-05-16 22:44:23hayposetmessages: + msg293817
2017-05-16 22:33:21jklothsetmessages: + msg293815
2017-05-16 22:26:00hayposetmessages: + msg293811
2017-05-16 22:21:49jklothsetmessages: + msg293810
2017-05-16 21:59:23hayposetmessages: + msg293805
2017-05-15 19:52:09jklothsetnosy: + jkloth
2017-05-15 16:17:12haypocreate